{
3 5
7 23 -5 -24 16
5 21 -4 10 23
-21 5 -4 -20 20

         
http://olympiads.win.tue.nl/ioi/ioi99/contest/index.html

			IOI'99 - Little Shop of Flowers
:
 F   ,   1  F,  V     1  V. 
(V >= F)         ,   
      .       
 (      1    ),    
     .    
         ""      
   .          
 -       -   ,       
  - .        
   ,        .

:
1-   F  V  (1<=F<=V<=100, -50 <=  "" <= 50)
  2-  F+1-   V  - ""   
   .. j-   (i+1)-  e ""  i-
  j- 

:
1-      
2-   F  -     ..  i-  
 2- e j,  i-     j.

:
      .

    3  (      
):
val(i,j) = ""  i-   j- ,     
 
(i,j) =        i  
  j    ( F<=V => a(i,j)    i<=j )  
     
used(i,j)=      i-     a(i,j)

 a(i,j) = max( a(i,j-1), a(i-1,j-1)+val(i,j) ) ..   i   j
     -   :
1.   i     j,        
   i   (j-1) ;
2.   i    j,    e    
(  i   j)       
i-1    j-1 ; 

   a(i,j)  used(i,j). ,   
  a(F,V)   used(i,j)     


10.I.2001					 
}

{$G+,Q-,R-,S-,M 16384,0,655360}
program Flower;
const
     InFile                     = 'flower.pas';
     OutFile                    = '';
     MaxF                       = 100;
     MaxV                       = 100;
     Infinity                   = 10000;
var
   Val, A, Used                 : array[0..MaxF,0..MaxV] of Integer;
   Flow, Vase                   : LongInt;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
   F                            : Text;
   I, J                         : Integer;
begin
  FillChar(Val, SizeOf(Val), 0);

  Assign(F, InFile); ReSet(F);
  ReadLn(F); {       .pas}
  ReadLn(F, Flow, Vase);
  for I := 1 to Flow do begin
    for J := 1 to Vase do Read(F, Val[I,J]);
    ReadLn(F);
  end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
   I, J, K, L                   : LongInt;
begin
  for I := 1 to MaxF do
    for J := 0 to MaxV do A[I,J] := -Infinity;
  for J := 0 to MaxV do A[0,J] := 0;

  for I := 1 to Flow do
    for J := I to Vase-Flow+I do begin
      if A[I,J-1] > A[I,J] then begin
        A[I,J] := A[I,J-1];
        Used[I,J] := Used[I,J-1];
      end;

      L := Val[I,J] + A[I-1,J-1];
      if L > A[I,J] then begin
        A[I,J] := L;
        Used[I,J] := J;
      end;
    end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
   F                            : Text;
   I, J, K, L                   : LongInt;
   Ans                          : array[1..MaxF] of Integer;
begin
  I := Flow; J := Vase;
  repeat
    Ans[I] := Used[I,J];
    J := Used[I,J]-1;
    Dec(I);
  until I = 0;

  Assign(F, OutFile); ReWrite(F);
  WriteLn(F, A[Flow,Vase]);
  Write(F, Ans[1]);
  for J := 2 to Flow do Write(F, ' ', Ans[J]);
  WriteLn(F);
  Close(F);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  Go;
  OutPut;
end.
