/*
3
2 0
3 0
0
 */
/*
  ' 2001
 4: TWOC

:
    N ,   1  N (0<N<99). 
       ,    . 
        ,  
 .   TWOC.EXE,     
         ,    , 
     ,     .  
    .       
      ,     
  .

:
              
(Breadth-First Search).     ,     
 -    .   -
  (        .)   
  .        .
         ,    
 .
    (FIFO , queue.)     
 .          
    -  .  -  
    .      
,     .      O(n).
 
mapto@softhome.net
 */
#include <stdio.h>

#define MAX 100

#define NONE -1
#define RED   0
#define BLUE  1

int neigh[MAX][MAX], neigh_n[MAX];
int color[MAX];
int n;
int queue[MAX];
int r, w;

int main( void )
{
  int i, j;

  freopen( "twoc.c", "r", stdin );

  scanf( "%*s%d", &n );
  for( i = 1; i <= n; neigh_n[i++] = j )
    for( j = neigh_n[i];; j++ )
    {
      scanf( "%d", &neigh[i][j] );
      if( !neigh[i][j] ) break;
      neigh[ neigh[i][j] ][ neigh_n[neigh[i][j]]++ ] = i;
    }
  for( i = 2; i <= n; color[i++] = -1 );
  queue[0] = 1, r = 0, w = 1;

  for( r = 0; r != w; r++ )
    for( j = 0; j < neigh_n[queue[r]]; j++ )
      if( color[ neigh[queue[r]][j] ] < 0 )
        color[ neigh[queue[r]][j] ] = 1 - color[queue[r]],
        queue[w++] = neigh[queue[r]][j];
      else if( color[ neigh[queue[r]][j] ] == color[queue[r]] )
      {
        printf( "-1" );
        return 0;
      }

  for( i = 1; i <= n; printf( "%d", color[i++] ));

  return 0;
}

