/*
        3: AMAX  '2001

       a(n)    
  .      
   a(n), ..   (  ) 
  O(1) () . ,     
 ,   ,       O(n).
  while    a()     
(    C)    lg2(n) .  ,    n
  C*lg2(n) .       
  
T = C*lg(1) + C*lg2(2) + C*lg2(3) +... + C*lg2(n) =
  = C*(lg2(1) + lg2(2) + lg2(3) +... + lg2(n)) = C * lg2(1*2*3*... *n).
     n! = sqrt(2*Pi*n)*(n/e)^n.
=> T = C * lg2(Q^n),   Q     . T.k. w 
   n,   2, C  Q    lgx(x^n) = n,
  ,      O(n).
 
mapto@softhome.net
 */
#include<fstream.h>

long int a(long int n)
{ long int i,j;
  i=1; j=0;
  while(n>1)
  {if(n%2) j=i+j; else i=i+j;
   n /= 2;
  }
  return i+j;
}

long int max(long int N)
{
 long int i,m,v;
 m=0;
 for(i=1;i<=N;i++)
  { v=a(i);if(m<v) m=v;}
 return m;
}

void main()
{
  long int N;
  fstream f, fout;
  f.open("AMAX.INP",ios::in);
  fout.open("AMAX.OUT",ios::out);
  f >> N;
  while(N>0)
  {
   fout << max(N) << endl;
   f >> N;
  }
  f.close();
  fout.close();
}

