/*
32 5702887
 */
/*
  ' 2001
 5: BLEX

:
     N (0<N<33),    0 
1  ,           ( 
)    .   BLEX.EXE,  
,   K-  (0<K<9999999)    
     .

:       ,     
   .

:
   : (n) =      n, 
 .  ,    0  (n-1), 
     1,       0. =>
     (n-2) => (n) = (n-1) + (n-2),  
      .  (0) = 1, .. ,
   1   .  (1) = 2 => , 
(n) = F(n+3),  F(n)     .
    k-         
.  - , 
(i-1) < k <= (i) <=> F(i+2) < k <= F(i+3),
  i-   1    ( .)    
    k = k - F(i+1).      ,
 .. k     ,   .
  ,      9999999  , 
-    (32) = F(35) = 5702887.   
F(n)       F(n) = (^n - (-)^n) / sqrt( 5 ),
  = (1 + sqrt( 5 )) / 2  - = (1 - sqrt( 5 )) / 2.
    O(n). ,  k  ,  
  ,     n, ..   
  ( ,)       .

        .   
        .     
      ,       o 
.
 
mapto@softhome.net
 */
#include <stdio.h>
#include <math.h>

int n, k;

int F( int n )
{
  return ( pow(( 1 + sqrt( 5 )) / 2, n ) - pow(( 1 - sqrt( 5 )) / 2, n )) / sqrt( 5 );
}

int main( void )
{
  int i;

  freopen( "blex.c", "r", stdin );
  scanf( "%*s%d %d", &n, &k );
  i = n - 1;

  if( k > F( i + 3 ) )
    printf( "-1" );
  else
    for(; k && i >= 0; i-- )
      if( F( i + 2 ) < k && k <= F( i + 3 ))
      {
         printf( "1" );
         k -= F( i + 2 );
      }
      else
         printf( "0" );

  return 0;
}

