/*
4
-2 2
-1 1
-3 3
 4 5
 */
/*
  ' 2001
 2: SEGS

:
     .      
    .     1  N (0<N<500).
,       ,      
      .   SEGS.EXE, 
     -   
   .    ,     ,
   ,      
.

:
       :
children[i] -      ,   i .
child[i] -    i ,   children[i]  .
      .
   .    i     
 j ,  i    j, children[j] < children[i] + 1.  
  ,  i  -     j  
(  .)     child[j]   children[j].
        "  ," - 
    .      children[i] 
( children[i]    i      .) 
 children[i]   ,  ..     
 ,   path       .
         .
     -   O(n^2),   
   .       , 
     .
 
mapto@softhome.net
 */
#include <stdio.h>
#include <stdlib.h>

#define MAX 500

int n;
struct { int b, e; } line[MAX];
int beg[MAX];
int children[MAX];
int child[MAX];
int path[MAX], pp;

void sort( void )
{
  int i, j, min, t;

  for( i = 1; i <= n; i++ )
  {
    for( min = i, j = i + 1; j <= n; j++ )
      if(( line[beg[j]].b < line[beg[min]].b )
       ||( line[beg[j]].b == line[beg[min]].b && line[beg[j]].e > line[beg[min]].e ))
        min = j;
    t = beg[min], beg[min] = beg[i], beg[i] = t;
  }
}

int main( void )
{
  int i, j, max;

  freopen( "segs.inp", "r", stdin );
  freopen( "segs.out", "w", stdout );

  scanf( "%d", &n );
  for( i = 1; i <= n; i++ )
    scanf( "%d %d", &line[i].b, &line[i].e );
  for( i = 1; i <= n; beg[i] = i++ );

  sort();

  for( i = n; i; i-- )
    for( j = 1; j < i; j++ )
      if( line[beg[j]].b < line[beg[i]].b && line[beg[j]].e > line[beg[i]].e )
        if( children[beg[j]] < children[beg[i]] + 1 )
          children[beg[j]] = children[beg[i]] + 1,
          child[beg[j]] = beg[i];

  for( i = 2, max = 1; i <= n; i++ )
    if( children[i] > children[max] )
      max = i;
  printf( "%d\n", children[max] + 1 );
  for( i = max;;)
  {
    path[pp++] = i;
    if( !child[i] ) break;
    i = child[i];
  }
  for( i = pp - 1; i >= 0; i-- )
    printf( "%d ", path[i] );

  return 0;
}

