/*
abcdhsttata
aabttafafcdxc

axbac
aabxc

    
( STRING   '2000)

:           A  B.
    X    Y,      Y
    X,     p  q  p   q  X,  p  
q   Y (  .)

:    :
   C  
A = { a[0], a[1],... , a[n-1] }, |A| = n;
B = { b[0], b[1],... , b[m-1] }, |B| = m;
C = { c[0], c[1],... , c[k-1] }, |C| = k.
            
 .    c[k-1]. .. C    A 
B,    a[i]  b[j],  c[k-1] = a[i] = b[j].  
  ,      c[k-1], a[i]  b[j]
.    C.   c[k-1].     A  i, 
 B - j. ..    ,   |A| = i, |B| = j,
|C| = k - 1.
..   C    n  m:
C(k)(n,m) = C(k-1)(i,j) + 1,
C(0)(0,0) = 0
   ,    i  j.    , :
 a[i] = b[j],  C(i,j) = C(i-1,j-1) <+> a[i] ( <+>  )
    ,  C  .
..   ,   ,   a[i] <> b[j], 
C(i,j) = max(C(i-1,j), C(i,j-1))
      .
    ,    , 
   ( A  B)   -   C  .   
      .  
  ,     .  , 
   .          
.          "" 
c(0,0)  c(n,m).
          
        .      ,
     .     
 , ..   .
       O(n*m), ..  
 n*m   .
      O(n+m), ..      
 .
   ?   .   
   ,    . ..      
 ,    .         
  ,          .
    -,      
 .  ,          ,
  ,         
. .. -         O(n*m)
(    )   O(n*m) ( C).
         . 
            
    (Computational Biology.)
 
mapto@softhome.net
*/
#include <stdio.h>

#define MAX 1000

#define max( a, b ) ( a > b ? a : b )

char a[MAX];
char b[MAX];
int n, m;
int c[MAX][MAX];

int main( void )
{
  int i, j;

  freopen( "lcs.c", "r", stdin );

  scanf( "%*s" );
  scanf( "%s%s", &a, &b );

  n = strlen( a );
  m = strlen( b );
  for( i = n - 1; i >= 0; i-- )
    for( j = n - 1; j >= 0; j-- )
      c[i][j] = a[i] == b[j] ? c[i + 1][j + 1]  + 1
                                 : max( c[i + 1][j], c[i][j + 1] );

  for( i = j = 0; i < n && j < m;)
    if( c[i][j] == c[i + 1][j + 1] + 1 )
    {
      printf( "%c", a[i] );
      i++, j++;
    }
    else
      if( c[i][j] == c[i + 1][j] )
        i++;
      else
        j++;

  return 0;
}

